#!/usr/bin/octave -qf
# Ulozit jako distance.m. 
# Spoustet jako: octave distance.m

# jeden radian
rad=180/pi

# namerene vzdalenosti (stupne)
r1 = 8
r2 = 25

# souradnice referencni hvezdy
# Aldebaran
a1 = 15*(4+36/60)
d1 = 16+30/60

# souradnice referencni hvezdy
# Capella
a2 = 15*(5+17/60)
d2 = 46

# vzdalenost referencnich hvezd 
#(priblizne 30 stupnu)
rad*acos(sin(d1/rad)*sin(d2/rad) + 
cos(d1/rad)*cos(d2/rad)*cos((a2-a1)/rad))

# priblizny (pocatecni) odhad
# polohy  Marsu
a = 15*4
d = 23

for i = 1:3

  # pomocne veliciny
  t1=sin(d1/rad)*sin(d/rad)+cos(d1/rad)\
    *cos(d/rad)*cos((a-a1)/rad)
  t2=sin(d2/rad)*sin(d/rad)+cos(d2/rad)\
    *cos(d/rad)*cos((a-a2)/rad)

  # prave strany, rozdil mezi merenou a 
  # vypoctenou vzdalenosti ve stupnich
     p = [ rad*acos(t1) - r1,
           rad*acos(t2) - r2]
   
  # rozdil vypoctene a merene vzdalenosti
  sqrt(p(1)**2+p(2)**2)

  # substituce
  u = -1/sqrt(1 - t1**2)
  v = -1/sqrt(1 - t2**2)

  # matice derivaci
  m = [ -u*sin((a-a1)/rad)*cos(d1/rad)*cos(d/rad),\
        u*(sin(d1/rad)*cos(d/rad) - \
           cos(d1/rad)*sin(d/rad)*cos((a-a1)/rad));\
        -v*sin((a-a2)/rad)*cos(d2/rad)*cos(d/rad),\
        v*(sin(d2/rad)*cos(d/rad) - \
           cos(d2/rad)*sin(d/rad)*cos((a-a2)/rad))]

  # vypocet inverzni matice
  [im,c] = inv(m)
 
  # vypocet linearnich rovnic
  x = -(im*p)
 
  # pricteni rozdilu k pocatecnimu odhadu
  a = a + x(1)
  d = d + x(2)

endfor

